//-----------------------------------------------------------------------------
//  Ted R. Smith
//  January 12, 2000
//  BeCalculative! v11:15PM_1_13_2000
//
//  If you use this source code, please email additional features/bug fixes to
//  admin@wakeup-people.com.  Also leave this notice here.  Thanks = )
//-----------------------------------------------------------------------------

#include <Alert.h>
#include <Application.h>
#include <Button.h>
#include <Font.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <TextControl.h>
#include <TextView.h>
#include <Window.h>
#include "Calculator.h"

float number_on_hold = 0;			// Previously entered number
bool EnteringNumbers = true;		// Typing a number?
int operand = 0;					// Operation variable

// Declarations of BeCalculative objects
BButton	*button1, *button2, *button3, *button4, *button5, *buttonENTER;
BButton	*button6, *button7, *button8, *button9, *button0, *buttonCLS;
BButton	*buttonDOT, *buttonDIV, *buttonX, *buttonSUB, *buttonADD, *buttonSIGN;
BButton *buttonHELP;
BTextControl *fTextField;
HydraWindow *aWindow;

// Main class call
HydraWindow::HydraWindow(BRect frame)
	: BWindow(frame, "BeCalculative", B_TITLED_WINDOW, B_NOT_RESIZABLE)
{
}


// Silly name for a SERIOUS function =)
// Appends the selected number to the end of the textbox.

void GetWeird(float number) {
	float new_num = 0;
	char number_string[8];
	float text_num=0;
	// Converts string to float
	text_num = atof(fTextField->Text());
	// Makes sure the number is valid.
	if (text_num < 10000000) {
		// Algebraically appends new number
		new_num = (text_num * 10) + number;
		// Standard C function to convert floats to strings
		sprintf(number_string,"%g",new_num);
		// Update fTextField
		fTextField->SetText(number_string);
	}
	// Gives alert if number is invalid.
	if (text_num == 999999) {
		BAlert *alert;
		alert = new BAlert("Alert", "Large Number Limit", "OK");
		alert->Go();
	}
}

// Meat of the algorithms.
void MathFunctions() {
	float number=0, new_number = 0;
	char number_string[8];
	
	// Converts string to float
	number = atof(fTextField->Text());
	
	// Determines what operation to execute
	switch(operand) {
		case 1: // Addition
			new_number = number_on_hold + number;
			break;
		case 2: // Subtraction
			new_number = number_on_hold - number;
			break;
		case 3: // Multiplication
			new_number = number_on_hold * number;
			break;
		case 4:	// Division
			new_number = number_on_hold / number;
			break;
		case 5:	// Decimal - Not implemented yet (Contribs accepted!)
			break;
		case 6: // Sign Swap - Positive becomes Negative and vice versa
			if (number_on_hold > 0) new_number = number_on_hold - (number_on_hold * 2);
			if (number_on_hold < 0) new_number = number_on_hold + (number_on_hold * -2);
			break;
	}
	
	sprintf(number_string, "%g", new_number);
	fTextField->SetText(number_string);
}

// Function that handles clicks and so forth
void HydraWindow::MessageReceived(BMessage* message)
{
	// message = BeOS global variable
	switch(message->what)
	{
		case BUTTON_1_MSG:
			// If user has stopped entering numbers, then clear the textbox
			if (EnteringNumbers == false) fTextField->SetText("");
			// Tell program that the user is now entering numbers
			EnteringNumbers = true;
			// Append the current number to the textbox
			GetWeird(1);
			break;
		case BUTTON_2_MSG:
			if (EnteringNumbers == false) fTextField->SetText("");
			EnteringNumbers = true;
			GetWeird(2);
			break;
		case BUTTON_3_MSG:
			if (EnteringNumbers == false) fTextField->SetText("");
			EnteringNumbers = true;
			GetWeird(3);
			break;
		case BUTTON_4_MSG:
			if (EnteringNumbers == false) fTextField->SetText("");
			EnteringNumbers = true;
			GetWeird(4);
			break;
		case BUTTON_5_MSG:
			if (EnteringNumbers == false) fTextField->SetText("");
			EnteringNumbers = true;
			GetWeird(5);
			break;
		case BUTTON_6_MSG:
			if (EnteringNumbers == false) fTextField->SetText("");
			EnteringNumbers = true;
			GetWeird(6);
			break;
		case BUTTON_7_MSG:
			if (EnteringNumbers == false) fTextField->SetText("");
			EnteringNumbers = true;
			GetWeird(7);
			break;
		case BUTTON_8_MSG:
			if (EnteringNumbers == false) fTextField->SetText("");
			EnteringNumbers = true;
			GetWeird(8);
			break;
		case BUTTON_9_MSG:
			if (EnteringNumbers == false) fTextField->SetText("");
			EnteringNumbers = true;
			GetWeird(9);
			break;
		case BUTTON_0_MSG:
			if (EnteringNumbers == false) fTextField->SetText("");
			EnteringNumbers = true;
			GetWeird(0);
			break;
		// ********************************
		//	Handles Function Keys:
		//	Add = 1			Times = 3
		//	Subtract = 2	Divide = 4
		//	Dot = 5			Sign = 6
		// ********************************
		case BUTTON_ADD_MSG:
			// Tell the program that the user is adding
			operand = 1;
			if (EnteringNumbers == true) {
				// Tell program that user has finished entering current number
				EnteringNumbers = false;
				// Compute number w/ previously computed one
				MathFunctions();
				// Convert string to float for use in next operation
				number_on_hold = atof(fTextField->Text());
			}
			break;
		case BUTTON_SUB_MSG:
			operand = 2;
			if (EnteringNumbers == true) {
				EnteringNumbers = false;
				MathFunctions();
				number_on_hold = atof(fTextField->Text());
			}
			break;
		case BUTTON_X_MSG:
			operand = 3;
			if (EnteringNumbers == true) {
				EnteringNumbers = false;
				// Make sure the accumlative answer is not reset to 0
				number_on_hold = 1;
				MathFunctions();
				number_on_hold = atof(fTextField->Text());
			}
			break;
		case BUTTON_DIV_MSG:
			operand = 4;
			if (EnteringNumbers == true) {
				EnteringNumbers = false;
				// Make sure the accumlative answer is not reset to 0
				number_on_hold = 1;
				MathFunctions();
				number_on_hold = atof(fTextField->Text());
			}
			break;
		case BUTTON_DOT_MSG:
			// Not implemented yet
			operand = 5;
			break;
		case BUTTON_SIGN_MSG:
			number_on_hold = atof(fTextField->Text());
			// Tell the program that user is still entering data, even though a 
			// function button was selected
			EnteringNumbers = false;
			operand = 6;
			// Process number
			MathFunctions();
			break;
		case BUTTON_HELP_MSG:
			// Shows About box
			BAlert *alert;
			alert = new BAlert("Help","Welcome to Ted's BeCalculative!\n\nThis is my first BeOS app.\n\n\tEVERY OS needs a calculator!\n\nSee README for *pertinent* info on bugs and stuff!","OK");
			alert->Go();
			break;
		case BUTTON_ENTER_MSG:
			// Signifies completion of algorithm, numbers sent to MathFunctions 
			// for processing
			EnteringNumbers = false;
			MathFunctions();
			// Store answer in buffer, just in case user wants to continue operations			
			number_on_hold = atof(fTextField->Text());
			break;
		case BUTTON_CLEAR_MSG:
			// Out of sight, out of mind
			fTextField->SetText("0.");
			break;
		// Signify that all messages were successfully received
		default:
			BWindow::MessageReceived(message);
	}

}

// be_app = BeOS global variable
// Handles program termination
bool HydraWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return(true);
}

// Sets up application threads
class HydraApplication : public BApplication {

public:
						HydraApplication();
};


// This is the GUI functions.
// X coordinates are scaled at 25 pts, starting at 5
// Y coordinates are scaled at 25 pts, starting at 35
HydraApplication::HydraApplication()
	: BApplication("application/x-vnd.dps-simpleapp")
{

	BRect		buttonRect;

	BRect aRect;
	aRect.Set(20, 60, 180, 250);
	aWindow = new HydraWindow(aRect);
	
	BRect textFieldRect(-145.0,10.0,150.0,70.0);
	fTextField = new BTextControl(textFieldRect, "TextField","", "0.",
				new BMessage(TEXT_FIELD_MSG));
	aWindow->AddChild(fTextField);

	buttonRect.Set(5.0, 35.0, 30.0, 60.0);
	button1 = new BButton(buttonRect, "One","1", new BMessage(BUTTON_1_MSG));
	aWindow->AddChild(button1);

	buttonRect.Set(35.0, 35.0, 60.0, 60.0);
	button2 = new BButton(buttonRect,"Two","2",new BMessage(BUTTON_2_MSG));						   
	aWindow->AddChild(button2);
	
	buttonRect.Set(65.0, 35.0, 90.0, 60.0);
	button3 = new BButton(buttonRect,"Three","3",new BMessage(BUTTON_3_MSG));						   
	aWindow->AddChild(button3);
	
	buttonRect.Set(5.0, 65.0, 30.0, 90.0);
	button4 = new BButton(buttonRect,"Four","4",new BMessage(BUTTON_4_MSG));						   
	aWindow->AddChild(button4);
	
	buttonRect.Set(35.0, 65.0, 60.0, 90.0);
	button5 = new BButton(buttonRect,"Five","5",new BMessage(BUTTON_5_MSG));						   
	aWindow->AddChild(button5);
	
	buttonRect.Set(65.0, 65.0, 90.0, 90.0);
	button6 = new BButton(buttonRect,"Six","6",new BMessage(BUTTON_6_MSG));						   
	aWindow->AddChild(button6);
	
	buttonRect.Set(5.0, 95.0, 30.0, 120.0);
	button7 = new BButton(buttonRect,"Seven","7",new BMessage(BUTTON_7_MSG));						   
	aWindow->AddChild(button7);

	buttonRect.Set(35.0, 95.0, 60.0, 120.0);
	button8 = new BButton(buttonRect,"Eight","8",new BMessage(BUTTON_8_MSG));						   
	aWindow->AddChild(button8);
	
	buttonRect.Set(65.0, 95.0, 90.0, 120.0);
	button9 = new BButton(buttonRect,"Nine","9",new BMessage(BUTTON_9_MSG));						   
	aWindow->AddChild(button9);
	
	buttonRect.Set(5.0, 125.0, 30.0, 140.0);
	button0 = new BButton(buttonRect,"Zero","0",new BMessage(BUTTON_0_MSG));						   
	aWindow->AddChild(button0);
	
	buttonRect.Set(35.0, 125.0, 60.0, 140.0);
	buttonDOT = new BButton(buttonRect,"Dot",".",new BMessage(BUTTON_DOT_MSG));						   
	aWindow->AddChild(buttonDOT);
	
	buttonRect.Set(65.0, 125.0, 90.0, 140.0);
	buttonSIGN = new BButton(buttonRect,"Sign"," ( - ) ",new BMessage(BUTTON_SIGN_MSG));						   
	aWindow->AddChild(buttonSIGN);	

	buttonRect.Set(95.0, 35.0, 120.0, 90.0);
	buttonDIV = new BButton(buttonRect,"Divide","/",new BMessage(BUTTON_DIV_MSG));						   
	aWindow->AddChild(buttonDIV);

	buttonRect.Set(125.0, 35.0, 150.0, 90.0);
	buttonX = new BButton(buttonRect,"Times","*",new BMessage(BUTTON_X_MSG));						   
	aWindow->AddChild(buttonX);

	buttonRect.Set(95.0, 95.0, 120.0, 150.0);
	buttonADD = new BButton(buttonRect,"Add","+",new BMessage(BUTTON_ADD_MSG));						   
	aWindow->AddChild(buttonADD);
	
	buttonRect.Set(125.0, 95.0, 150.0, 150.0);
	buttonSUB = new BButton(buttonRect,"Minus","--",new BMessage(BUTTON_SUB_MSG));						   
	aWindow->AddChild(buttonSUB);

	buttonRect.Set(5.0, 155.0, 30.0, 180.0);
	buttonHELP = new BButton(buttonRect, "Help", " ? ", new BMessage(BUTTON_HELP_MSG));
	aWindow->AddChild(buttonHELP);

	buttonRect.Set(35.0, 155.0, 120.0, 180.0);
	buttonENTER = new BButton(buttonRect,"Enter","Enter",new BMessage(BUTTON_ENTER_MSG));						   
	aWindow->AddChild(buttonENTER);

	buttonRect.Set(125.0, 155.0, 150.0, 180.0);
	buttonCLS = new BButton(buttonRect, "Clear", "C", new BMessage(BUTTON_CLEAR_MSG));
	aWindow->AddChild(buttonCLS);

	aWindow->Show();
}



// Starts the threads on their merry little lives = )
main()
{
	HydraApplication myApplication;

	myApplication.Run();

	return(0);
}